var venueTypes;

$(document).ready(async () => {
    await loadVenueTypes();
    await loadVenues();
});

const loadVenueTypes = async () => {
    const response = await $.ajax({
        url: "/api/venues",
        method: "OPTIONS"
    });

    venueTypes = response?.actions?.POST?.type?.choices || [];
}

const loadVenues = async () => {
    const response = await $.ajax({
        url: "/api/venues/",
        method: "GET"
    });

    for (const venue of response?.results || []) {
        addVenue(venue);
        addVenue(venue);
        addVenue(venue);
        addVenue(venue);
        addVenue(venue);
        addVenue(venue);
        addVenue(venue);
        addVenue(venue);
        addVenue(venue);
        addVenue(venue);
    }
}

const addVenue = venue => {
    let $venue = $($("#venueItemTemplate").html());

    const type = venueTypes.find(type => type.value === venue.type);

    $venue.find(".venue-type").text(type.display_name);
    $venue.find(".venue-item").data("id", venue.id);
    $venue.find(".venue-name").text(venue.name);
    $venue.find(".venue-description").text(venue.description);

    const phoneNumber = venue.contacts?.phone_number;
    addVenueTemplateContact(
        $venue,
        phoneNumber,
        `tel:${phoneNumber}`,
        "bi-telephone"
    );

    const emailAddress = venue.contacts?.email_address;
    addVenueTemplateContact(
        $venue,
        emailAddress,
        `mailto:${emailAddress}`,
        "bi-envelope"
    );

    $venue.off("click").on("click", async () => await selectVenue(venue.id));

    $("#venueContainer").append($venue);
}

const addVenueTemplateContact = ($venue, value, url, iconClass) => {
    if (!value) {
        return;
    }

    let $contact = $($("#venueContactTemplate").html())

    $contact.find(".venue-contact-url").attr("href", url);
    $contact.find(".venue-contact-icon")
        .addClass(iconClass)
        .attr("data-bs-title", value)
        .attr("data-bs-toggle", "tooltip")
        .tooltip();

    $venue.find(".venue-contacts").append($contact);
}

const selectVenue = async id => {
    const response = await $.ajax({
        url: `/api/venues/${id}/`,
        method: "GET"
    })

    alert(JSON.stringify(response, null, 4));
}
